package xmdv.dataproc;



/***********************************************************

**  CopyRight (c) by Xmdv Group, CS Department of WPI, 2003

**  All Rights Reserved.

**

**  Author: Jing Yang

**  Date:   06/2003

***********************************************************/



/**

 * This class is an implementation of the abstract class AbstractDimension. 

 * An instance of it can be used to manage a double dimension.

 *

 * @author  Jing Yang

 * @version v1.0

 */

public class DoubleDimension extends AbstractDimension {

    // Variables declaration

    protected double max = Double.MAX_VALUE;

    protected double min = Double.MIN_VALUE;

    // End of variables declaration

    

    /** Creates new DoubleDimension */

    public DoubleDimension() {

    }

    

    /**

     * Sets the maximum value of this dimension.  

     * @param maxString the string that contains the maximum value

     */

    public void setMax(String maxString) {

        this.origMaxString = maxString;

        max = Double.parseDouble(maxString);

        if (max < min)

            max = min + 200;

    }

        

    /**

     * Sets the minimum value of this dimension.  

     * @param minString the string that contains the minimum value

     */

    public void setMin(String minString) {

        this.origMinString = minString;

        min = Double.parseDouble(minString);

        if (min > max)

            min = max - 200;

    }

    

    /**

     * Adds a rim to this dimension so that the real range of this 

     * dimension is a little bit larger that the input range  

     */

    public void addRim() {

        double rim = (max - min)/20;

        max = max + rim;

        min = min - rim;

    }

        

    /**

     * Gets a message contains the dimension name and a data value.  

     * @param norValue the normalized value of the data

     */

    public String getNamedValueMessage(double norValue) {

        return name + " = " + getValueMessage(norValue);

    }

    

    /**

     * Gets a message contains a data value.  

     * @param norValue the normalized value of the data

     */

    public String getValueMessage(double norValue) {

        double value = norValue * (max - min) + min;

        return "" + new Double(value).floatValue();

    }

    

    /**

     * Gets the normalized value of a data.  

     * @param valueString the data in a string

     */

    public double getNorValue(String valueString) {

        double value = Double.parseDouble(valueString);

        return (value - min) / (max - min);

    }

}